Subject: Re: [PATCH iproute2-next] bpf: fix snprintf truncation warning

From: Stephen Hemminger <[email-masked]>
Date: Thu, 5 Sep 2019 08:51:47 -0700

On Thu, 5 Sep 2019 13:44:55 +0200
Andrea Claudi <[email-masked]> wrote:

> On Thu, Sep 5, 2019 at 12:15 AM David Ahern <[email-masked]> wrote:
> >
> > On 9/4/19 9:50 AM, Andrea Claudi wrote:  
> > > gcc v9.2.1 produces the following warning compiling iproute2:
> > >
> > > bpf.c: In function ‘bpf_get_work_dir’:
> > > bpf.c:784:49: warning: ‘snprintf’ output may be truncated before the last format character [-Wformat-truncation=]
> > >   784 |  snprintf(bpf_wrk_dir, sizeof(bpf_wrk_dir), "%s/", mnt);
> > >       |                                                 ^
> > > bpf.c:784:2: note: ‘snprintf’ output between 2 and 4097 bytes into a destination of size 4096
> > >   784 |  snprintf(bpf_wrk_dir, sizeof(bpf_wrk_dir), "%s/", mnt);
> > >       |  ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
> > >
> > > Fix it extending bpf_wrk_dir size by 1 byte for the extra "/" char.
> > >
> > > Signed-off-by: Andrea Claudi <[email-masked]>
> > > ---
> > >  lib/bpf.c | 2 +-
> > >  1 file changed, 1 insertion(+), 1 deletion(-)
> > >
> > > diff --git a/lib/bpf.c b/lib/bpf.c
> > > index 7d2a322ffbaec..95de7894a93ce 100644
> > > --- a/lib/bpf.c
> > > +++ b/lib/bpf.c
> > > @@ -742,7 +742,7 @@ static int bpf_gen_hierarchy(const char *base)
> > >  static const char *bpf_get_work_dir(enum bpf_prog_type type)
> > >  {
> > >       static char bpf_tmp[PATH_MAX] = BPF_DIR_MNT;
> > > -     static char bpf_wrk_dir[PATH_MAX];
> > > +     static char bpf_wrk_dir[PATH_MAX + 1];
> > >       static const char *mnt;
> > >       static bool bpf_mnt_cached;
> > >       const char *mnt_env = getenv(BPF_ENV_MNT);
> > >  
> >
> > PATH_MAX is meant to be the max length for a filesystem path including
> > the null terminator, so I think it would be better to change the
> > snprintf to 'sizeof(bpf_wrk_dir) - 1'.  
> 
> With 'sizeof(bpf_wrk_dir) - 1' snprintf simply truncates at byte 4095
> instead of byte 4096.
> This means that bpf_wrk_dir can again be truncated before the final
> "/", as it is by now.
> Am I missing something?
> 
> Trying your suggestion I have this slightly different warning message:
> 
> bpf.c: In function ‘bpf_get_work_dir’:
> bpf.c:784:52: warning: ‘/’ directive output may be truncated writing 1
> byte into a region of size between 0 and 4095 [-Wformat-truncation=]
>   784 |  snprintf(bpf_wrk_dir, sizeof(bpf_wrk_dir) - 1, "%s/", mnt);
>       |                                                    ^
> bpf.c:784:2: note: ‘snprintf’ output between 2 and 4097 bytes into a
> destination of size 4095
>   784 |  snprintf(bpf_wrk_dir, sizeof(bpf_wrk_dir) - 1, "%s/", mnt);
>       |  ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Why not rework this to use asprintf and avoid having huge buffers on stack?